//       -      
//    txt     
#include <lib_cisnewbar.mqh>
#property indicator_separate_window
#property indicator_plots 2
#property indicator_buffers 2 

#property indicator_type1 DRAW_HISTOGRAM
#property indicator_color1 Lime
#property indicator_style1 STYLE_SOLID
#property indicator_label1 "Tick "

#property indicator_type2 DRAW_HISTOGRAM 
#property indicator_color2 Red
#property indicator_style2 STYLE_SOLID
#property indicator_label2 "Tick "

double   UpTick[];
double   DnTick[];
double   _Bid,_Ask,TickUp,TickDn,difference;
double   Time[];
MqlTick tick_array[];
CisNewBar current_chart;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_FILE_SAVE
  {
   NOT_SAVE,       //   
   SAVE            // 
  };
input ENUM_FILE_SAVE  Save_File=NOT_SAVE;    //  
input int countHistoryTicks=10000;
input int countHistoryBars=1000;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct TickStruct                                                                                  //       
  {
   datetime          time;
   double            bid;
   double            ask;
  };
TickStruct        g_ticks[];                                                                       //    ,                         
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,UpTick,INDICATOR_DATA);
   SetIndexBuffer(1,DnTick,INDICATOR_DATA);
   PlotIndexSetInteger(0,PLOT_LINE_WIDTH,2);
   PlotIndexSetInteger(1,PLOT_LINE_WIDTH,2);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,clrLime);
   PlotIndexSetInteger(1,PLOT_LINE_COLOR,clrRed);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);
   IndicatorSetInteger(INDICATOR_DIGITS,5);

   int copied=CopyTicks(_Symbol,tick_array,COPY_TICKS_ALL,0,countHistoryTicks);
   if(Save_File!=NOT_SAVE)
     {
      SaveTicksToFile(tick_array);
     }
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   if(prev_calculated==0)
     {
      LoadOldData(time);
     }
   MqlTick last_tick;
   SymbolInfoTick(Symbol(),last_tick);
//      
   if(current_chart.isNewBar()>0)
     {
      TickUp=0;
      TickDn=0;
     }
   if(_Bid == 0) _Bid = last_tick.bid;  //             Bid
   if(_Ask == 0) _Ask = last_tick.ask;  //  Ask
//---

   if(IsFirstMoreThanSecond(last_tick.ask,_Ask)) //     
     {
      TickUp++;                                     //   Volume 
     }
   if(IsFirstMoreThanSecond(_Bid,last_tick.bid)) //     
     {
      TickDn--;                                     //   Volume 
     }
   difference=TickUp+TickDn; //      
   if(difference>0)
     {
      UpTick[rates_total-1]=difference;
      DnTick[rates_total-1]=0;
     }
   else
     {
      UpTick[rates_total-1]=0;
      DnTick[rates_total-1]=difference;
     }
   _Bid = last_tick.bid;
   _Ask = last_tick.ask;
//--    
/////////////////////////////////////////////////
   return(rates_total);
  }
//+------------------------------------------------------------------+
bool IsFirstMoreThanSecond(double first,double second)
  {
   return (first - second > Point() / 10);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ArrayFree(g_ticks);
   ArrayFree(UpTick);
   ArrayFree(DnTick);
   ArrayFree(tick_array);
  }
//+------------------------------------------------------------------+

void LoadOldData(const datetime  &time[])
  {
   int total=ArraySize(tick_array);
   int i=1;
   TickUp=0;
   TickDn=0;
   int indexBar=0;
   int indexBarOld=0;
   int tempIndexBar=0; //          ,    ,    
   while(i<total)
     {
      datetime tick_time=tick_array[i].time;
      if(tempIndexBar==0)
        {
         indexBar=checkBarTime(tick_time,time);
         tempIndexBar=indexBar;
        }
      else//      ,  ,       
        {
         indexBar=checkBarTimeWithTempIndexBar(tick_time,time,tempIndexBar);
         tempIndexBar=indexBar;
        }
      if(indexBar!=indexBarOld)
        {
         difference=TickUp+TickDn; //      
         if(difference>0)
           {
            UpTick[indexBar]=difference;
            DnTick[indexBar]=0;
           }
         else
           {
            UpTick[indexBar]=0;
            DnTick[indexBar]=difference;
           }
         TickUp=0;
         TickDn=0;
        }
      if(IsFirstMoreThanSecond(tick_array[i].ask,tick_array[i-1].ask))
        {
         TickUp++;
        }
      if(IsFirstMoreThanSecond(tick_array[i-1].bid,tick_array[i].bid))
        {
         TickDn--;
        }
      indexBarOld=indexBar;
      i++;
     }
  }
//+------------------------------------------------------------------+
int checkBarTime(datetime tickTime,const datetime  &time[])
  {
   int totalSizeTime=ArraySize(time);
   int i=totalSizeTime-countHistoryBars;
   while(i<totalSizeTime-3)
     {
      if((tickTime>=time[i-1]) && (tickTime<time[i]))
        {
         return (i-1);
        }
      i++;
     }
   return (0);
  }
//+------------------------------------------------------------------+

int checkBarTimeWithTempIndexBar(datetime tickTime,const datetime  &time[],int tempIndBar)
  {
   if((tickTime>=time[tempIndBar]) && (tickTime<time[tempIndBar+1]))
     {
      return (tempIndBar);
     }

   int totalSizeTime=ArraySize(time);
   int i=totalSizeTime-countHistoryBars;
   while(i<totalSizeTime-1)
     {
      if((tickTime>=time[i-1]) && (tickTime<time[i]))
        {
         return (i-1);
        }
      i++;
     }
   return (0);
  }
//+------------------------------------------------------------------+

void SaveTicksToFile(MqlTick &massiveTicks[])
  {
   string filename,file_buffer;
//      path_prefix, 
//     ".txt"
   StringConcatenate(filename,Symbol(),".txt");
//      ,  ANSI,    
   int file_handle=FileOpen(filename,FILE_READ|FILE_WRITE|FILE_ANSI|FILE_SHARE_READ);

   FileSeek(file_handle,0,SEEK_END);
//  ,     
   int sizeMassiveTicks=ArraySize(massiveTicks);
   int i=0;
   while(i<sizeMassiveTicks)
     {
      StringConcatenate(file_buffer,TimeToString(massiveTicks[i].time,TIME_DATE|TIME_SECONDS)," ",DoubleToString(massiveTicks[i].bid,_Digits)," ",DoubleToString(massiveTicks[i].ask,_Digits)," ",DoubleToString(massiveTicks[i].last,_Digits)," ",IntegerToString(massiveTicks[i].volume,_Digits)," ",IntegerToString(massiveTicks[i].time_msc)," ",IntegerToString(massiveTicks[i].flags,_Digits));
      //    
      FileWrite(file_handle,file_buffer);
      i++;
     }
   FileClose(file_handle);
  }
//+------------------------------------------------------------------+
